LeetCode OJ算法题(五十九):Permutation Sequence

来源:互联网 发布:excel 数据连接 编辑:程序博客网 时间:2024/06/03 19:05

题目:

The set [1,2,3,…,n] contains a total of n! unique permutations.

By listing and labeling all of the permutations in order,
We get the following sequence (ie, for n = 3):

  1. "123"
  2. "132"
  3. "213"
  4. "231"
  5. "312"
  6. "321"

Given n and k, return the kth permutation sequence.

Note: Given n will be between 1 and 9 inclusive.

解法:

要求生成第k个排列,第一感觉是使用next Permutation的方法,调用k次,但是这样感觉开销太大,应该可以直接通过k和n算出结果的。

观察第一位的数字,如果k<(n-1)!那么该位肯定是1,如果k在n-1的阶乘和2倍的n-1的阶乘之间,那么该位为2,以此类推,因此可以用(k-1)/(n-1)!来判断第一位是多少,然后递归产生第二位,第三位。。。但是注意元素只能使用一次,因此我用了HashSet来保存使用过的数字。

import java.util.HashSet;public class No59_PermutationSequence {public static void main(String[] args){System.out.println(getPermutation(3, 1));}public static String getPermutation(int n, int k) {        if(k > factorial(n)) return "";        HashSet<Integer> set = new HashSet<Integer>();        return getP(n, k, set);    }public static String getP(int n, int k, HashSet<Integer> set){if(n == 1){int r = 1;while(set.contains(r))r++;return ""+r;} int tmp = factorial(n-1);int first = 0;int i = 0;do{first++;while(set.contains(first)) first++;i++;}while(i <= (k-1)/tmp);set.add(first);return ""+first+getP(n-1, k%tmp==0?tmp:k%tmp, set);}public static int factorial(int n){if(n==0 || n==1) return 1;return factorial(n-1) * n;}}


0 0
原创粉丝点击